#!/usr/bin/env python
#
# Breadcrumb Cache Builder
# Copyright (C) 2005, 2013 Nicholas J. Haggin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys, os, re, dbm
from urlparse import urljoin

uriBase = "http://www.semperubisububi.net"
matchCrumb = re.compile('<meta name="crumb" content="(.*)"/>', re.IGNORECASE)

def buildCrumbCache(wwwBase, db):
    for root, dirs, files in os.walk(wwwBase):
        if 'cgi-bin' in dirs: dirs.remove('cgi-bin')
        for name in files:
            name = os.path.join(root, name)
            uri = urljoin(uriBase, name)
            uri = uri.replace('index.shtml', '')
            uri = uri.replace(wwwBase + '/', '')
            if os.path.isfile(name):
                crumb = matchCrumb.search(file(name, 'r').read())
                if crumb:
                    print uri, crumb.group(1)
                    db[uri] = crumb.group(1)

if __name__ == '__main__':
    base = sys.argv[1]
    db = dbm.open(os.path.join(base, '.crumbs'), 'c')
    buildCrumbCache(base, db)
    db.close()
