#!/usr/bin/env python
#
# Breadcrumb Generator
# Copyright (C) 2005, 2013 Nicholas J. Haggin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys, os, re, anydbm, cgi
from urlparse import urljoin, urlsplit
import cgitb; cgitb.enable()

def genCrumbs():
    crumbCache = anydbm.open(os.path.join(os.getenv('DOCUMENT_ROOT'), '.crumbs'), 'r')
    uri = 'http://' + os.getenv('HTTP_HOST')
    request = os.getenv('REQUEST_URI').split('/')
    if request[-1] == '': del request[-1]
    crumbs = []
    separator = ' &gt; '
    for item in request:
        uri = urljoin(uri, item)
        try:
            crumb = crumbCache[uri]
        except KeyError:
            uri = uri + '/'
            try:
                crumb = crumbCache[uri]
            except KeyError:
                continue

        crumbs.append('<a href="' + uri + '">' + crumb + '</a>')

    print '<div id="crumbs">'
    print separator.join(crumbs)
    print '</div>'

if __name__ == '__main__':
    print 'Content-Type: text/plain\n\n'
    genCrumbs()
